use strict;
use warnings;
use ExtUtils::MakeMaker;

WriteMakefile(
    NAME                => 'bbsdbpl',
    AUTHOR              => 'Robert James Clay <jame@rocasa.us>',
    VERSION        	=> '0.2',
    ABSTRACT       	=> 'Perl scripts for using an SQL database for an Fidonet/FTN compatible BBS.',
    EXE_FILES           => [ qw( bin/areasbbsadm.pl bin/areatable.pl bin/bbs2pkt.pl bin/bbs2txt.pl
			     bin/bbsdbpladm.pl bin/pkt2bbs.pl bin/txt2bbs.pl ) ],
    PL_FILES            => {},
    PREREQ_PM => {
        'Getopt::Std'   	=> 0,
        'DBI'   		=> 0,
        'DBD::SQLite'   	=> 0,
        'FTN::Log'   		=> 0.02,
    },
    dist                => { COMPRESS => 'gzip -9f', SUFFIX => 'gz', },
    clean               => { FILES => 'bbsdbpl-*' },
);
