#!/usr/bin/perl
#
#  txt2bbs.pl  - v0.2 
# This is a script to post a msg from the contents of a file
# to a MySQl bbs database 
#  Copyright (c) 2001-2004,2010 Robert James Clay.  All Rights Reserved.
#  This is free software;  you can redistribute it and/or
#  modify it under the same terms as Perl itself.
#
use warnings;
use strict;
use Getopt::Std;
use vars qw/ $opt_a $opt_c $opt_f $opt_n $opt_d $opt_p $opt_t $opt_s
             $opt_h $opt_l $opt_x /;

my ($db_handle, $sql_statement, $attrib, $area, $datetime, $from_node, $to_node,
    $from, $to, $subj, $message_body, $messaage_line, $message_serial, $message_id,
     $log_file, $DEBUG);
 
# Setup

getopts('a:c:f:n:d:p:t:s:l:hx');


if($opt_h) {

    print "\ntxt2bbs.pl -c [areaname] -f [filename]  -n [from_node] -d [to node] \\ \n";
    print " -p [fromname ] -t [toname] -s [subject] -a [attributes]\n [-x]";
    print " Defaults\n";
    print "  areaname = TESTECHO        filename = message.txt\n";
    print "  tonode = 1:120/545         from_node = 1:120/545.4\n";
    print "  fromname = Sysop           toname = All\n";
    print "  subject  = Testing	        attrib = 0 \n\n";
    exit;
}

if ($opt_x) {
    $DEBUG = $opt_x;	# set debug flag
    undef $opt_x;
    print "\nDebug flag is set ...\n";
} else {
    $DEBUG = 0;
}
	
if ($opt_a) {
    $attrib=$opt_a;  #  atributes as an int?  set of letters?
} else {
    $attrib="0";  # need a better default...
}

if ($opt_c) {
    $area=$opt_c;
} else {
    $area="TESTECHO";
}

#  read body of msg from file or set default test msg body.
if ($opt_f) {
    $message_body="";
    open (MSGFILE, "<$opt_f") or die ("Cannot open file: $opt_f");
    while (read (MSGFILE, $messaage_line, 1)){
	$message_body .= $messaage_line;
    }
    close (MSGFILE);
} else {
    $message_body="\n   Testing...\n\n";
}

#
if ($opt_n) {
    $from_node=$opt_n;  
} else {
    $from_node="1:120/544.1";  
#  read default from somewhere else?
}

#
if ($opt_d) {
    $to_node=$opt_d;  
} else {
    $to_node="1:120/544"; 
  
#  read default from somewhere else?
}

#
if ($opt_p) {
    $from=$opt_p;  
} else {
    $from="Sysop"; 

  
#  read default from somewhere else?
}

#
if ($opt_t) {
    $to=$opt_t;  
} else {
    $to="All"; 
 # defaults to All
}

#
if ($opt_s) {
    $subj=$opt_s;  
} else {
    $subj="Testing"; 
 # default subject
}

if ($opt_l) {
    $log_file=$opt_l;  # this needs to be the filename & path
    undef $opt_l;
} else {
    $log_file="bbsdbpl.log";		# default log file
}


&getdatetime();  # sets $datetime to current ftsc format time

#   this needs to be an 8 digit hex number.
$message_serial="00000005";	  # use something to generate msg id's?
$message_id="$from_node $message_serial";
      
##  
#    $message_body .= "$mailer\n" if ($mailer);
#    $message_body .= " * Origin: bbsdbpl point   (1:120/545.4)\n";
#    $message_body .= "$seenby\n";

# connect to database
#   Assumes that $db_name, $db_user, & $db_password are set as follows
# in the database.  (see ftndbtst.pl)

my $db_name = 'ftndbtst';
my $db_user = 'sysop';
my $db_password = 'ftntstpw';
 
use DBI;

( $db_handle = DBI->connect("dbi:mysql:dbname=$db_name", $db_user, $db_password) )
    or  die $DBI::errstr;
      
    $sql_statement = "INSERT INTO ";
    $sql_statement .= $area;
    $sql_statement .= "(ftscdate,from_node,tonode,fromname,toname,";
    $sql_statement .= "subject,msg_id,local,body) ";   # "local" -> "attrib"
    $sql_statement .= "VALUES (";
    $sql_statement .= "'$datetime', ";
    $sql_statement .= "'$from_node', ";
    $sql_statement .= "'$to_node', ";
    $sql_statement .= "'$from', ";   
    $sql_statement .= "'$to', ";
    $sql_statement .= "'$subj', ";
    $sql_statement .= "'$message_id', ";   
    $sql_statement .= "'Y', ";	#  needs to be replaced w/ new correct code
#   msg body then added to sql_statment
    $sql_statement .= $db_handle->quote($message_body);
    $sql_statement .= ") ";

#print " $sql_statement ";

    $db_handle->do( "$sql_statement " )
	or die $DBI::errstr;

# disconnect from database
( $db_handle->disconnect )
    or  die $DBI::errstr;

exit();

###################################
# getdatetime
###################################
sub getdatetime {
    my ($sec, $min, $hour, $mday, $mon, $year, $year_off, $wday, @moy);  
    @moy = ('Jan','Feb','Mar','Apr','May','Jun',
            'Jul','Aug','Sep','Oct','Nov','Dec');
    ($sec, $min, $hour, $mday, $mon, $year_off, $wday) = localtime();
    $year = substr ($year_off, 2);
    $datetime = sprintf("%d %s %02d  %02d:%02d:%02d",
            $mday, $moy[$mon], $year, $hour, $min, $sec);
}

